var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

var elementIDs = [      
    "offbydefault",
    "contextmenu"   
];

var rdTree;
var rdTreeView;

treeView.prototype = {

invalidate: function()
{
    this.treebox.invalidate();
},

swap: function(idx1, idx2)
{
    if ((idx1 == idx2) || (idx1 < 0) || (idx2 < 0))
        return;

    var temp = this.items[idx1];

    this.items[idx1] = this.items[idx2];
    this.items[idx2] = temp;

    if (this.defaultsignature == idx1)
    {
        this.defaultsignature = idx2;
    }
    else if (this.defaultsignature == idx2)
    {
        this.defaultsignature = idx1;
    }
},

insertItem: function(newItem)
{
    try
    {
        this.items.push(newItem);
        this.treebox.rowCountChanged(this.rowCount, 1);
    }
    catch (err)
    {
        alert(err);
    }
},

deleteSelectedItem: function()
{
    try
    {
        var selIdx = this.selection.currentIndex;

        if (selIdx < 0)
            return;

        var newItems = new Array();

        for (var i = 0; i < this.items.length; i++)
        {
            if (i != selIdx)
                newItems.push(this.items[i]);
        }

        if (selIdx == this.defaultsignature)
            this.defaultsignature = -1;

        this.items = newItems;
        this.treebox.rowCountChanged(selIdx, -1);

        if (newItems.length > 0)
            this.selection.select(selIdx == 0 ? 0 : selIdx - 1);
    }
    catch (err)
    {
        alert(err);
    }
},

getCellText: function(row, column)
{
    switch (typeof(column) == "object" ? column.id : column)
    {
        case "default":
            return (row == this.defaultsignature ? "Y" : "N");
        case "description":
            return this.items[row].description;
        case "rd":
            return this.items[row].rd;
        default:
            return "";
    }
},

setTree: function(treebox)
{
    this.treebox = treebox;
},

cycleCell: function(row, column)
{
    if ((typeof(column) == "object" ? column.id : column) == "default")
    {
        if (row == this.defaultsignature)
        {
            this.defaultsignature = -1;
        }
        else
        {
            var currDef = this.defaultsignature;
            this.defaultsignature = row;
            this.items[row].isVisible = true;
            this.treebox.invalidateCell(currDef, column);
        }
    }

    // this.treebox.selection.select(row);
    this.selection.select(row);
    this.treebox.invalidateRow(row);
},

getImageSrc: function(row, column) {
    if ((typeof(column) == "object" ? column.id : column) == "default") {
        if (row == this.defaultsignature)
            return "chrome://subjects_prefix_switch/skin/default.png";
    }

    return null;
},

get rowCount()
{
    return this.items.length;
}, 

isContainer: function(row) { return false; },
isSeparator: function(row) { return false; },
isSorted: function(row) { return false; },
cycleHeader: function(col, elem) {},
getLevel: function(row) { return 0; },
getRowProperties: function(row, props) {},
getCellProperties: function(row, col, props) {},
getColumnProperties: function(colid, col, props) {}
};

function treeView(items, defaultsignature)
{
this.items = items;
this.defaultsignature = defaultsignature;
this.treebox = null;
}

function onLoad()
{
var elementID;
var element;
var eltType;
var defpref;


for (var i = 0; i < elementIDs.length; i++)
{
    elementID = elementIDs[i];
    element = document.getElementById(elementID);

    if  (!element) break;

    eltType = element.localName;
    str.data = element.getAttribute("defaultpref");

    if  (eltType == "radiogroup")
    {
        try
        {
            element.selectedItem = element.childNodes[pref.getIntPref(element.getAttribute("prefstring"))];
        }
        catch (e)
        {
            element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
            try
            {
                pref.setIntPref(element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
            }
            catch (e) {}
        }
    }
    else if (eltType == "checkbox")
    {
        try
        {
            element.checked = (pref.getBoolPref(element.getAttribute("prefstring")));
        }
        catch(e)
        {
            defpref = element.getAttribute("defaultpref");
            element.checked = (defpref == "true");
            try
            {
                pref.setBoolPref(element.getAttribute("prefstring"), (defpref == "true"));
            }
            catch (e) {}
        }
    }
    else if (eltType == "textbox")
    {
        try
        {
            element.setAttribute("value", pref.getComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString).data);
        }
        catch (e)
        {
            element.setAttribute("value", element.getAttribute("defaultpref"));
            try
            {
                pref.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
            }
            catch (e) {}
        }
    }
    else if (eltType == "menulist")
    {
        try
        {
            element.insertItemAt(0, pref.getComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString).data);
            element.selectedIndex = 0;
        }
        catch (e)
        {
            element.insertItemAt(0, element.getAttribute("defaultpref"));
            element.selectedIndex = 0;
            try
            {
                pref.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
            }
            catch (e) {}
        }
    }
}

initTree();

if (window.arguments && window.arguments[0])
    document.documentElement.acceptDialog();
}

function initTree() {
  var treeData = loadTreeData();
  var defaultRD = -1;

  try {
      defaultRD = parseInt(pref.getCharPref("extensions.subjects_prefix_switch.defaultrd"));
  } catch(e) {}

  rdTree = document.getElementById("subjects_prefix_switchTree");
  rdTreeView = new treeView(treeData, defaultRD);
  rdTree.view = rdTreeView;
  rdTreeView.invalidate();
  onSelectItem();
}

function loadTreeData() {
  var dataString;
  var items = new Array();

  try {
    dataString = pref.getComplexValue("extensions.subjects_prefix_switch.rds", Components.interfaces.nsISupportsString).data;

    if (dataString != "") {
        var itemStrings = dataString.split("|");

        var itemData;

        for (var i = 0; i < itemStrings.length; i ++) {
            itemData = itemStrings[i].split("*");

            items.push(new createItem(itemData[0], itemData[1]));
        }
    }
  } catch (e) {}
  
  return items;
}

function onDialogAccept() {
  var elementID;
  var element;
  var eltType;

  for (var i = 0; i < elementIDs.length; i++) {
    elementID = elementIDs[i];
    element = document.getElementById(elementID);

    if  (!element) break;

    eltType = element.localName;

    if  (eltType == "radiogroup")
        pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
    else if  (eltType == "checkbox")
        pref.setBoolPref(element.getAttribute("prefstring"), element.checked);
    else if (eltType == "textbox" && element.preftype == "int")
        pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.getAttribute("value")));
    else if (eltType == "textbox") {
        str.data = element.value;
        pref.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
    } else if (eltType == "menulist") {
        str.data = element.selectedItem.label;
        pref.setComplexValue(element.getAttribute("prefstring"), Components.interfaces.nsISupportsString, str);
    }
  }

  saveTreeData();
}

function saveTreeData() {
  var dataString = "";
  var rowCount = rdTreeView.rowCount;

  for (var i = 0; i < rowCount ; i++) {
      if (dataString == "") {
          dataString =    
              rdTreeView.getCellText(i, "description")    + "*" + rdTreeView.getCellText(i, "rd");
      } else {
          dataString =    dataString + "|" +
              rdTreeView.getCellText(i, "description")    + "*" + rdTreeView.getCellText(i, "rd");
      }
  }

  str.data = dataString;
  pref.setComplexValue("extensions.subjects_prefix_switch.rds", Components.interfaces.nsISupportsString, str);
  pref.setCharPref("extensions.subjects_prefix_switch.defaultrd", rdTreeView.defaultsignature);
}

function onDialogCancel(){
}

function onSelectItem() {
  var selIdx = rdTreeView.selection.currentIndex;
  var rowCount = rdTreeView.rowCount;

  document.getElementById("up").disabled = selIdx <= 0;
  document.getElementById("down").disabled = selIdx < 0 || selIdx >= rowCount - 1;
  document.getElementById("delete").disabled = selIdx < 0;
  document.getElementById("edit").disabled = selIdx < 0;

  return true;
}

function newItem() {
  var item = new createItem("", "");

  window.openDialog("chrome://subjects_prefix_switch/content/setrd.xul", "_blank", "chrome,modal,resizable=yes,dependent=yes", item);
  if (item.path != "" && item.description != "") {
    rdTreeView.insertItem(item);
    rdTreeView.invalidate();
  }
}

function editItem() {
  var selIdx = rdTreeView.selection.currentIndex;
  if (selIdx < 0)
    return;

  window.openDialog("chrome://subjects_prefix_switch/content/setrd.xul", "_blank", "chrome,modal,resizable=yes,dependent=yes", rdTreeView.items[selIdx]);

  rdTreeView.invalidate();
}

function deleteItem() {
  rdTreeView.deleteSelectedItem();
  rdTree.focus();
}

function createItem(description, rd) {
  this.description = description;
  this.rd = rd;
}

function moveItem(moveUp) {
  var fromIdx = rdTreeView.selection.currentIndex;
  var toIdx;

  rdTree.focus();

  if (moveUp) {
    if (fromIdx <= 0)
        return;

    toIdx = fromIdx - 1;
  } else {
    if (fromIdx >= rdTreeView.rowCount - 1)
        return;

    toIdx = fromIdx + 1;
  }

  rdTreeView.swap(fromIdx, toIdx);
  rdTreeView.invalidate();
  rdTreeView.selection.select(toIdx);
  rdTreeView.treebox.ensureRowIsVisible(toIdx);
}

function getLocalizedMessage(msg) {
  return document.getElementById("subjects_prefix_switch.locale").getString(msg);
}

function openURL(aURL) {
  var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
  var protocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"].getService(Components.interfaces.nsIExternalProtocolService);

  uri.spec = aURL;
  protocolSvc.loadUrl(uri);
}
